import urllib2 
from xml.dom import minidom
import string
from string import Template
import os
import fileinput

ACCESS_KEY_ID = "1CE7SK4ZPTNDQZCWBP82"

review_template = 'http://www.amazon.com/review/product/$ISBN/ref=cm_cr_dp_all_summary?_encoding=UTF8&showViewpoints=1&sortBy=bySubmissionDateDescending'
amazon_template = 'http://ecs.amazonaws.com/onca/xml?Service=AWSECommerceService&AWSAccessKeyId='+ACCESS_KEY_ID+'&Operation=ItemLookup&ItemId=$ISBN&ResponseGroup=Reviews'

calibre_dir = "C:\\Progra~1\\calibre\\"
separator="~~~"
cmdline_tool = "calibredb.exe"
option_list = " list"
option_isbn = " --fields=isbn,rating,title,timestamp"
option_sep = " --separator="+separator
option_get_meta = " show_metadata --as-opf "
option_set_meta = " set_metadata "

isbns = dict()
books = 0
books_no_isbn = 0
books_already_have_review = 0
books_retrieved_review = 0
no_review = 0

# Populate a dictionary of all of our book ISBN's and their corresponding calibre id's
file = os.popen(calibre_dir+cmdline_tool+option_list+option_isbn+option_sep, 'r')
i = 1
while 1:
    line = file.readline()
    if not line:
        break
    elif i > 1:
        if string.find(line, '~~~200') != -1:
            isbn_info = line.split(separator)
            isbn_info = map(string.strip,isbn_info)
            junk = isbn_info.pop()
            junk = isbn_info.pop()
            if isbn_info[1] == "":
                print "ISBN not available for "+isbn_info[3]
                books_no_isbn = books_no_isbn + 1
            else:
                isbns[isbn_info[1]] = [isbn_info[0],isbn_info[2],isbn_info[3]]
            books = books + 1
    i = i + 1

isbn_list = isbns.keys()
abort_this_book = 0
for books_isbn in isbn_list:
    #print "Processing: "+isbns[books_isbn][2]
    # Grab the book rating from Amazon and form a URL to the books Amazon review page.
    if isbns[books_isbn][1] == "0":
        print "Retrieving rating for "+isbns[books_isbn][2]
        amazonURL = Template(amazon_template)
        ecsURL = amazonURL.substitute(ISBN = books_isbn)
        ecsNameSpace = "http://webservices.amazon.com/AWSECommerceService/2005-10-05" 
        respXML = minidom.parse(urllib2.urlopen(ecsURL)) 
        for items in respXML.getElementsByTagNameNS(ecsNameSpace, "Items"):
            try:
                rating = items.getElementsByTagName("Item")[0].getElementsByTagName("AverageRating")[0].toxml()
                break
            except IndexError:
                print "No Amazon review info for "+isbns[books_isbn][2]
                no_review = no_review + 1
                abort_this_book = 1
                break

        if abort_this_book == 1:
            abort_this_book = 0
            continue
        rating = rating.replace('<AverageRating>','')
        rating = rating.replace('</AverageRating>','')
        rating_num = float(rating)
        rating_url = Template(review_template)
        review = rating_url.substitute(ISBN = books_isbn )
        review = "<a href=\""+review+"\">Amazon Rating: "+rating+"</a><br />"
        meta_update_filename = books_isbn+".opf"
        #print calibre_dir+cmdline_tool+option_get_meta+isbns[books_isbn]+' > '+meta_update_filename
        # get the metadata for the book in opf format
        os.system(calibre_dir+cmdline_tool+option_get_meta+isbns[books_isbn][0]+' > '+meta_update_filename )
        # add the Rating information and Review link
        #opf_file = file.open(meta_update_filename,'w')
        for line in fileinput.FileInput(meta_update_filename,inplace=1):
            if "calibre:rating" in line:
                line=line.replace("0",str(int(rating_num*2)))
            #elif "<dc:description>SUMMARY:" in line:
            #    line=line.replace("<dc:description>SUMMARY:","<dc:description>"+review+"<br />SUMMARY:")
            print line,
        # Now update the calibre meta information for the book
        os.system(calibre_dir+cmdline_tool+option_set_meta+isbns[books_isbn][0]+" "+meta_update_filename)
        #print "Found rating for "+isbns[books_isbn][2]+": "+rating
        books_retrieved_review = books_retrieved_review + 1
    else:
        #print "Already have rating for "+isbns[books_isbn][2]+": "+isbns[books_isbn][1]
        books_already_have_review = books_already_have_review + 1

print "\n\nProcessed %d books"  % (books)
print "Found %d books with no ISBN" % (books_no_isbn)
print "Found %d books already reviewd" % (books_already_have_review)
print "Found %d books with no Amazon review" % (no_review)
print "Retrieved reviews for %d books" % (books_retrieved_review)